
 { to obtain value for for GreenWich SideReal Time
   coeffitients are in memory }

 UNIT Un2000_U ;

 INTERFACE

 Function ToGetGSTime ( DateJulUT1  : Extended ) : Extended ; { in radian }

 Function ToGetGMSTime ( DateJulUT1  : Extended ) : Extended ; { in radian }

 IMPLEMENTATION

 Uses
   UnConTyp , Un2000_C , Un2000_L , Un2000_P , Un2000_r ;

 { a new value for the GreenWich SideReal Time in radian }

 Function ToGetGSTime ( DateJulUT1  : Extended ) : Extended ;
 Const
   ma  : Array[1..2] of Byte  = ( 33 , 1 ) ;
   na  : Array[1..34,1..14] of ShortInt =
      { j = 0  Nb of terms = 33 }
 ( (  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  0,  0,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2, -2,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2, -2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2, -2,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2,  0,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  0,  0,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  0,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1,  2, -2,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1,  2, -2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  4, -4,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  1, -1,  1,  0, -8, 12,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2,  0,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  2,  0,  3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  2,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2, -2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1, -2,  2, -3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1, -2,  2, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  0,  0,  0,  0,  8,-13,  0,  0,  0,  0,  0, -1 ) ,
   (  0,  0,  0,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  2,  0, -2,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  0, -2,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  1,  2, -2,  2,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0,  0, -2, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  4, -2,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  0,  0,  2, -2,  4,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0, -2,  0, -3,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
   (  1,  0, -2,  0, -1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ,
      { j = 1  Nb of terms =  1 }
   (  0,  0,  0,  0,  1,  0,  0,  0,  0,  0,  0,  0,  0,  0 ) ) ;
   aa  : Array[1..34,1..2] of Single =
      { j = 0  Nb of terms = 33 }
 ( (   2640.96 ,   -0.39 ) ,
   (     63.52 ,   -0.02 ) ,
   (     11.75 ,    0.01 ) ,
   (     11.21 ,    0.01 ) ,
   (     -4.55 ,    0.00 ) ,
   (      2.02 ,    0.00 ) ,
   (      1.98 ,    0.00 ) ,
   (     -1.72 ,    0.00 ) ,
   (     -1.41 ,   -0.01 ) ,
   (     -1.26 ,   -0.01 ) ,
   (     -0.63 ,    0.00 ) ,
   (     -0.63 ,    0.00 ) ,
   (      0.46 ,    0.00 ) ,
   (      0.45 ,    0.00 ) ,
   (      0.36 ,    0.00 ) ,
   (     -0.24 ,   -0.12 ) ,
   (      0.32 ,    0.00 ) ,
   (      0.28 ,    0.00 ) ,
   (      0.27 ,    0.00 ) ,
   (      0.26 ,    0.00 ) ,
   (     -0.21 ,    0.00 ) ,
   (      0.19 ,    0.00 ) ,
   (      0.18 ,    0.00 ) ,
   (     -0.10 ,    0.05 ) ,
   (      0.15 ,    0.00 ) ,
   (     -0.14 ,    0.00 ) ,
   (      0.14 ,    0.00 ) ,
   (     -0.14 ,    0.00 ) ,
   (      0.14 ,    0.00 ) ,
   (      0.13 ,    0.00 ) ,
   (     -0.11 ,    0.00 ) ,
   (      0.11 ,    0.00 ) ,
   (      0.11 ,    0.00 ) ,
      { j = 1  Nb of terms =  1 }
   (     -0.87 ,    0.00 ) ) ;
 Var
   farg   : TFundArg ;
   t,DateJulian  : Extended ;
   iq,mm,ia,ka,kb  : Byte ;
   sp,sr,rr,
   qq,aq,sa,ca,rg,rq    : Extended ;
   teta,epso,epsa,dpsi  : Extended ;
   dplu,delu,dppl,depl  : Extended ;
 Begin
   DateJulian:=DateJulUT1;
   { teta for the Earth rotation angle in radian }
   teta:=ToGetEarthRotAngle(DateJulUT1);
   FundArgLuSo(DateJulian,farg);
   FundArgPlan(DateJulian,farg);
   t:=(DateJulian-JD2000)/JulianC; { from the fundamental epoch in century }
   sp:=0.014506+(+4612.15739966
               +(+1.39667721+(-0.00009344+0.00001882*t)*t)*t)*t;
   sp:=SecRad*sp;  { polynomial part in radian }
   { periodic part with the coefficients in memory }
   sr:=0.0; { unitial nullo for periodic part }
   qq:=1.0; { t in power 0 }
   kb:=0;
   For ia:=1 To 2 Do
     Begin
       ka:=kb+1; { from ka }
       kb:=kb+ma[ia]; { to kb for coefficients }
       For mm:=ka To kb Do
         Begin
           aq:=0.0;
           For iq:=1 To 14 Do
             aq:=aq+na[mm,iq]*farg[iq];
           sa:=Sin(aq);
           ca:=Cos(aq);
           sr:=sr+qq*(aa[mm,1]*sa+aa[mm,2]*ca); { in microarcsec }
         End;
       qq:=qq*t;
     End;
   sr:=1.0e-6*SecRad*sr; { periodic part in radian }
   epso:=SecRad*84381.448; { in radian }
   epsa:=epso+SecRad*(-46.84024+(-0.00059+0.001813*t)*t)*t; { in radian }
   NutParmLuSo(DateJulian,dplu,delu); { unit Un2000_L luni-solar nutation }
   NutParmPlan(DateJulian,dppl,depl); { unit Un2000_P planetary  nutation }
   dpsi:=SecRad*(dplu+dppl); { from arcsec to radian }
   rr:=teta+sp+dpsi*Cos(epsa)+sr;
   rq:=Int(rr/(2*Pi));
   rg:=rr-2*Pi*rq;
   If  rg < 0  Then  rg:=rg+2*Pi;
   ToGetGSTime:=rg; { in radian }
 End;

 Function ToGetGMSTime ( DateJulUT1  : Extended ) : Extended ; { in radian }
  Var
   t,d,teta,sp  : Extended ;
 Begin
   d:=DateJulUT1;
   { teta for the Earth rotation angle in radian }
   teta:=ToGetEarthRotAngle(DateJulUT1); { from Un2000_r }
   t:=(d-JD2000)/JulianC; { from the fundamental epoch in century }
   sp:=0.014506+(+4612.15739966
               +(+1.39667721+(-0.00009344+0.00001882*t)*t)*t)*t;
   sp:=SecRad*sp;  { polynomial part in radian }
   ToGetGMSTime:=teta+sp; { in radian }
 End;

 END.
