unit UnVakPow ; { elements to power }
interface
{ power a^1 e^i s^i c^i for some i 
  to the axicur and arrays eccmow sinmow cosmow from UnTypVar }
procedure ToGetPowerValue ( aa , ee , si , ci  : Extended ) ;
implementation
uses
  UnTypVar ; { global var axicur eccmow[..] sinmow[..] cosmow[..] }
{ power a^1 e^i s^i c^i for some i
  to the axicur and arrays eccmow sinmow cosmow from UnTypVar }
procedure ToGetPowerValue ( aa , ee , si , ci  : Extended ) ;
var
  i  : ShortInt ; { integer value for power }
begin
  axicur:=aa;                    { current value a^1 }
  eccmow[0]:=1.0;                { initial e^0 global UnTypVar }
  for i:=1 to maxpec do          { for positive powers }
    eccmow[i]:=ee*eccmow[i-1];   { the positive power of e }
  sinmow[0]:=1.0;                { initial s^0 global UnTypVar }
  for i:=1 to maxpsc do          { for positive powers }
    sinmow[i]:=si*sinmow[i-1];   { the positive power of s }
  cosmow[0]:=1.0;                { initial c^0 global UnTypVar }
  for i:=1 to maxpsc do          { for positive powers }
    cosmow[i]:=ci*cosmow[i-1];   { the positive power of c }
end;
end.
