program rowmuvao;
{$APPTYPE CONSOLE}
uses
  UnTypVar , { procedures GetRowMem FreeRowMem global variable axinul }
  UnForPrt , { text file for protocol PrtFile }
  UnVakAxi , { procedure ToGetMeanAxis }
  UnReadFi , { procedure FromFileToMem for copy }
  UnRowIni , { for RecNullo RowNullo procedures }
  UnGetERP , { procedure ToOpenERPFile }
  UnHarMod , { procedure ToObtainAllHarmValues }
  UnitCeil , { for class TCeil ceiler }
  UnitDeil , { for class TDeil deiler }
  UnitDelm , { for class TDelm delmer }
  UnStarto , { ToStartProcess ToStartPromean }
  UnTusDoi , { proc ForOrbitImprove }
  UnStuFel ; { proc ToFinishProcess }
begin

  ToOpenPrtFile('rowmuvao.zrt'); { UnForPrt protocol }

  GetRowMem ;    { from UnTypVar for memory }
                 { the place in memory for arrays }
  RecNullo ;     { UnRowIni nullo record recnul of TRowVar }
  RowNullo ;     { UnRowIni initial nullo record to arrays }
                 { function from UnVakAxi global UnTypVar }
  axinul:=ToGetMeanAxis; { semimajor axis in km mean value }

                 { to copy secular term from file to array }
  FromFileToMem('seclong.zun',meccoh,rowcoh); { UnReadFi }
                 { meccoh number of terms in array rowcoh^ }

                 { to copy secular term for Solar pressure }
  FromFileToMem('seclong.zup',mecaux,rowaux); { UnReadFi }
                 { mecaux number of terms in array rowaux^ }
                 { to copy short.p term for Solar pressure }
  FromFileToMem('shortrm.zup',mectmp,rowtmp); { UnReadFi }
                 { mectmp number of terms in array rowtmp^ }

  { to copy all short periodic terms
    to any arrays from rowone^ to rowsix^ if it is necessary }
  ShorTermToMem ; { from file shortrm.zun may be six arrays }

  ToOpenERPFile ; { UnGetERP for Earth rotation parameters }

  { for var GemParmValue[1..4] }
  ToObtainAllHarmValues('jgm3.dat'); { UnHarMod }

  ceiler:=TCeil.Create ;         { UnitCeil to create class }
  ceiler.ToClcInitValues ;       { UnitCeil it is necessary }

  deiler:=TDeil.Create ;         { UnitDeil to create class }

  delmer:=TDelm.Create ;         { UnitDelm to create class }

  { initial text file with information rowmuvak.inz
    to read initial elements in two-line elements format
    to read name of file with observations guick look format
    to assigned global variables
    IntTime.begday .cursec UnForTyp
    DayStart equal Inttime.begday start moment in julian day
    ElmStart initial six nonsingular elements for improving process }
  ToStartPromean ; { UnStarto ElmStart a l+g+h e*cos(g+h) e*sin(g+h)... }

  { laser observations are now in binary file binqlos.tmp }
  ForOrbitImprove ; { UnTusDoi process of data adjusting }

  { after adjusting to write new set of elements }
  ToFinishPromean ; { UnStuFel new elements in tle format }

  ToCloseERPFile ; { UnGetERP }

  FreeRowMem ;     { from UnTypVar }

  ToClosePrtFile ; { UnForPrt protocol }

end.
