 UNIT UnForPrt ; { for simple Text files }
 INTERFACE
 Var
   PrtFile   : TextFile ;
   ResFile   : TextFile ;
   RezFile   : TextFile ;
   MaxPrtF   : Byte ;
 Procedure ToOpenPrtFile ( str  : ShortString ) ;
 Procedure ToClosePrtFile ;
 Procedure ToOpenResFile ( str  : ShortString ) ;
 Procedure ToCloseResFile ;
 Function BooExistResult ( str  : ShortString ) : Boolean ;
 IMPLEMENTATION
 Procedure ToOpenPrtFile ( str  : ShortString ) ;
 Begin
   MaxPrtF:=0;
   AssignFile(PrtFile,str);
 {$I-}
   ReWrite(PrtFile);
 {$I+}
   If  IOResult <> 0
     Then
       Begin
         AssignFile(PrtFile,'NUL');
         ReWrite(PrtFile);
       End;
 End;
 Procedure ToClosePrtFile ;
 Begin
   CloseFile(PrtFile);
 End;
 Procedure ToOpenResFile ( str  : ShortString ) ;
 Begin
   AssignFile(ResFile,str);
 {$I-}
   ReWrite(ResFile);
 {$I+}
   If  IOResult <> 0
     Then
       Begin
         AssignFile(ResFile,'NUL');
         ReWrite(ResFile);
       End;
 End;
 Procedure ToCloseResFile ;
 Begin
   CloseFile(ResFile);
 End;
 Function BooExistResult ( str  : ShortString ) : Boolean ;
 Begin
   BooExistResult:=FALSE;
   If  str = 'NUL'  Then  Exit ;
   AssignFile(RezFile,str);
 {$I-}
   ReSet(RezFile);
 {$I+}
   If  IOResult = 0
     Then { file with the name  str  exists }
       Begin
         BooExistResult:=TRUE;
         CloseFile(RezFile);
       End;
 End;
 END.