unit UnReadFi ; { to read file to memory }
interface
uses
  UnTypVar ; { for type TRowPtr for array type TRowVar for record }
procedure FromFileToMem ( s  : ShortString ;    { name of file }
                          var  n  : Word ;      { number of terms }
                          var  g  : TRowPtr ) ; { array for terms }
{ to copy all short periodic terms to any files }
procedure ShorTermToMem ; { from file shortrm.zun }
implementation
{ copy all records from binary file to array in memory }
procedure FromFileToMem ( s  : ShortString ;    { name of file }
                          var  n  : Word ;      { number of terms }
                          var  g  : TRowPtr ) ; { array for terms }
var
  f  : file of TRowVar ; { binary file with records }
  r  : TRowVar ;         { record to read type UnTypVar }
begin
  AssignFile(f,s); { binary file    const maxarr }
  ReSet(f);        { to open to read    UnTypVar }
  n:=0;            { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin               { to read term by term }
      Read(f,r);        { the next record }
      n:=n+1;           { the next number of term }
      g^[n]:=r;         { this term to array }
    end;
  CloseFile(f);    { after reading } 
end;
{ to copy all short periodic terms to any files }
procedure ShorTermToMem ; { from file shortrm.zun }
var
  f  : file of TRowVar ; { binary file with records }
  r  : TRowVar ;         { record to read type UnTypVar }
  n  : Word ;            { simple count }
begin
  AssignFile(f,'shortrm.zun'); { binary file    const maxarr }
  ReSet(f);        { to open to read    UnTypVar }
  { the first portion of terms to array rowone }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowone^[n]:=r; { this term to array }
    end;             { the first portion }
  mecone:=n;         { number of terms in array }
  { the second portion of terms to array rowtwo }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowtwo^[n]:=r; { this term to array }
    end;             { the first portion }
  mectwo:=n;         { number of terms in array }
  { the third portion of terms to array rowtre }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowtre^[n]:=r; { this term to array }
    end;             { the first portion }
  mectre:=n;         { number of terms in array }
  { the fourth portion of terms to array rowfur }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowfur^[n]:=r; { this term to array }
    end;             { the first portion }
  mecfur:=n;         { number of terms in array }
  { the fifth portion of terms to array rowfiv }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowfiv^[n]:=r; { this term to array }
    end;             { the first portion }
  mecfiv:=n;         { number of terms in array }
  { the sixth portion of terms to array rowsix }
  n:=0;              { initial nullo term in array }
  while  ( ( not EOF(f) ) and ( n < maxarr ) )  do
    begin            { to read term by term }
      Read(f,r);     { the next record }
      n:=n+1;        { the next number of term }
      rowsix^[n]:=r; { this term to array }
    end;             { the first portion }
  mecsix:=n;         { number of terms in array }
  CloseFile(f);    { after reading } 
end;
end.
